#!/usr/bin/perl

# example for the gimp-perl-server (also called Net-Server)

use Gimp qw( :auto );
# use Gimp::OO;

# Gimp::set_trace(TRACE_NAME);

sub one_page {
  my $img, $page, $drawable, $textlayer, $mask, $shade, $float;
  my $num = shift;
  $img = gimp_file_load("interactive", "/home/kas/tex/linux/cikhaj/pozadi1.tif", "pozadi1.tif");
  $page = gimp_file_load("non-interactive", "/home/kas/tex/linux/cikhaj/$num.pgm", "$num.pgm");
  gimp_selection_all($page);
  $drawable = gimp_image_active_drawable($page);
  gimp_edit_copy($page,$drawable);
  gimp_image_delete($page);
  $textlayer = gimp_layer_new($img,800,600,RGBA_IMAGE, "text", 100, NORMAL);
  gimp_image_add_layer($img,$textlayer,0);
# gimp_edit_paste($img,$drawable1,'clear');
  $mask = gimp_layer_create_mask($textlayer,WHITE_MASK);
  gimp_image_add_layer_mask($img,$textlayer,$mask);
  gimp_layer_set_edit_mask($textlayer,1);
  $float=gimp_edit_paste($img, $mask, 'clear');
  gimp_floating_sel_anchor($float);
  gimp_invert($img,$mask);
  gimp_layer_set_edit_mask($textlayer,0);
  gimp_selection_all($img);
#  gimp_palette_set_foreground("#fff080");
  gimp_palette_set_background("#fff050");
  gimp_edit_fill($img,$textlayer);
  gimp_image_remove_layer_mask($img,$textlayer,APPLY);
  $shade = gimp_layer_new($img,800,600,RGBA_IMAGE, "shade", 100, NORMAL);
  gimp_image_add_layer($img,$shade,1);
  gimp_palette_set_background("#000000");
  gimp_selection_all($img);
  gimp_edit_clear($img,$shade);
  gimp_selection_layer_alpha($img,$textlayer);
  gimp_selection_feather($img, 2);
  gimp_edit_fill($img, $shade);
  gimp_layer_translate($shade, 3, 2);
  $textlayer=gimp_image_flatten($img);
  gimp_selection_none($img);
  gimp_file_save(1,$img, $textlayer, "/home/kas/tex/linux/cikhaj/$num.tif", "$num.tif");
#  $display = gimp_display_new($img);

  gimp_image_delete($img);
}

sub net {
	for $num (<stranka*.pgm>) {
		$num =~ s/\.pgm$//;
		$|=1;
		print "Rastering page $num ...";
		one_page($num);
		print " done.\n";
	}
}
exit gimp_main;




