/* ----- pklad 2. ----- */
#include <stdio.h>
#include <string.h>		/* strcmp()            */
#include <proc/readproc.h>	/* readproctab         */
#include <proc/version.h>	/* set_linux_version() */
#include <proc/sysinfo.h>	/* uptime()            */
#include <sys/param.h>		/* HZ                  */
#include <time.h>		/* time()              */

#define RE_ERROR	1
#define RE_OK		0

   int	GL_current_time, CL_Sum;
   long	GL_time_now;

/* This function is from ps(1) - ps.c 
 * Copyright (c) 1992 Branko Lankester
 * Changes Copyright (C) 1993, 1994 Michael K. Johnson,
 *   and   Copyright (C) 1995, 1996 Charles Blake,
 *   and   Copyright (C) 1996       Helmut Geyer 
 */
   void get_pcpu(proc_t *p) {
      int total_time, seconds;
      time_t start;
      unsigned int pcpu=0;
   
      seconds = (((GL_current_time * HZ) - p->start_time) / HZ);
      start = GL_time_now - seconds;
      total_time = (p->utime + p->stime  + 
                   (CL_Sum ?   p->cutime + p->cstime : 0));
      pcpu = seconds ? (total_time * 10 * 100/HZ) / seconds : 0;
      if (pcpu > 999) pcpu = 999;
      p->pcpu = pcpu;
   }

   int main(int argc, char **argv)
   {
      proc_t	**pt;	
      int	proc_num=0, mem_max=0, cpu_max=0;
   
      if (argc > 1)
         if (!(strcmp(argv[1], "-c")))
            CL_Sum = 1;
   
      set_linux_version();
      if (!(GL_current_time = uptime(0,0))) 
         exit(RE_ERROR);
      GL_time_now = time(0L);
      pt = readproctab(PROC_FILLTTY | PROC_FILLUSR | PROC_FILLMEM);
   
      while(pt[proc_num] != NULL) {
      /* --- mem --- */
         if (pt[proc_num]->resident > pt[mem_max]->resident)
            mem_max = proc_num;
      /* --- cpu --- */ 
         get_pcpu(pt[proc_num]);    	 	
         if (pt[proc_num]->pcpu > pt[cpu_max]->pcpu)
            cpu_max = proc_num; 	
         ++proc_num;
      }      
      printf("\nPROCESS  : %d\n", proc_num);
      puts("PROCES WITH MAX. RESIDENT MEMORY:");
      printf("\tName     : %s\n",         pt[mem_max]->cmd);
      printf("\tPID      : %d\n",         pt[mem_max]->pid);
      printf("\tSTATE    : %c\n",         pt[mem_max]->state);
      printf("\tUSER     : %s\n",         pt[mem_max]->user); 
      printf("\tTTY      : %s\n",         pt[mem_max]->ttyc);
      printf("\tRESIDENT : %ld (pages)\n", pt[mem_max]->resident);  
      puts("PROCES WITH MAX. %CPU:");
      printf("\tName     : %s\n",         pt[cpu_max]->cmd);
      printf("\tPID      : %d\n",         pt[cpu_max]->pid);
      printf("\tSTATE    : %c\n",         pt[cpu_max]->state); 
      printf("\tUSER     : %s\n",         pt[cpu_max]->user); 
      printf("\tTTY      : %s\n",         pt[cpu_max]->ttyc);
      printf("\t%%CPU     : %.1f", (float) pt[cpu_max]->pcpu/10);    
      if (CL_Sum) 
         puts(" (cumulative)\n");
      else
         puts("\n");
   
      exit(RE_OK);
   }
